/* VisPro/REXX */

_VPAppHandle = VpInit()
if _VPAppHandle='' then exit
_VPAppReturn = 0

/* Open first form */
Parse arg topic
_VPMainWindow = VpOpenForm('', 256, topic)
if _VPMainWindow='' then do
   call VpMessageBox 0,'VisPro/REXX','Unable to open Main form.  Verify that there is a Main form, that it has an id of 256, and that the form has controls within it.'
   signal _VPAppExit
end

do until ( _VPEventCall=='')
   _VPEventCall = VpGetMsg(_VPAppHandle)
   Interpret _VpEventCall
end
/* Terminate application */
_VPAppExit:
call VpQuit _VPAppHandle
return _VPAppReturn


/* ##262_Form.1 */
262_Form.1: /* Form events - Opened */
Arg window 

/* set window postion */
rc = SysIni(progini, "aboutwin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end

return

/* ##262_Form.2 */
262_Form.2: /* Form events - Closed */
Arg window 
/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "aboutwin", "mainpos", rc)


return

/* ##261_1000.0 */
261_1000.0: /* Event Clicked/selected - Container  1000 */
Arg window self index
/*

value=VpGetItemValue(window,1000,INDEX) 
SAY 'VALUE' VALUE
CALL VpLoadFromFile window,1000,'FOLDERS',value
RC=SYSSLEEP(5)
CALL VpItem window,ITEMID,'SENDMSG','0x034e',index,'0' /*COLAPSE*/
/*CALL VpItem window,ITEMID,'SENDMSG','0x034e'*/ /*COLAPSE*/
/*CALL VpItem window,1000,'SENDMSG','0x034f',index,'0'*/

/*ESTO ME DA LA LISTA DE FILES DE C:\*/
/*CALL VpLoadFromFile window, 1000,'C:\'  */

*/
return

/* ##261_1000.3 */
261_1000.3: /* Event Container  1000, Changed */
Arg window self index

value=VpGetItemValue(window,1000,INDEX) 
SAY 'VALUE' VALUE
CALL VpLoadFromFile window,1000,'FOLDERS',value
/*CALL VpItem window,1000,'SENDMSG','0x034f',index,'0' */
/*CALL VPSETITEMVALUE(WINDOW,1000,'C:\OS2')*/

return

/* ##261_FORM.1 */
261_FORM.1: /* Event Form events, Opened */
Arg window 
rc=VpSetItemStyle(window, 1000,'TREE')
 call SysSetObjectData '1000', 'Open=TREE'
 CALL VpLoadFromFile window,1000,'FOLDERS',value
/* WE ASK FOR THE USED DRIVES ON THIS MACHINE */
index=VpGetIndex(window,1000,'FIRSTCHILD',index) 
SAY INDEX 'INDEXCHILD'
driveslist=SysDriveMap("C:","USED")
icon=VpLoadPicture('SYSBITMAP',18)
say value icon
do i=1 to words(driveslist)
 if subword(driveslist,i,1)<>"B:" then do
 /* Add item to end 1000 Combo Box */
 index=VpAddItem(window, 1000, 'END', subword(driveslist,i,1),ICON)
/* index=VpAddItem(window,1000,'CHILD',subword(driveslist,i,1),index) */
/*
VALUE.I=subword(driveslist,i,1)
VALUE.0=I
*/
 end
end
CALL VpLoadFromFile window,1000,'FOLDERS',VALUE.1
/* Get index of value 1000 Combo Box */
index=VpGetIndex(window,1000,'SEARCH',substr(defaultdrive,1,2))

/* Select item 1000 Combo Box */

CALL VpSelect window,1000,1,1

return

/* ##258_1000.0 */
258_1000.0: /* Event Clicked/selected - Search directory  1000 */
Arg window self

value=VpOpenForm(window, 301, value)
mainwindow=window
return

/* ##258_1000.10 */
258_1000.10: /* Event Mouse move - Directory select  1000 */
Arg window self x y
call vpitem window,1003,'FORECOLORRGB','255'
call vpsetitemvalue window,1003,' '


return

/* ##258_1001.10 */
258_1001.10: /* Event Mouse move -   1001 */
Arg window self x y
call vpitem window,1003,'FORECOLORRGB','255'
call vpsetitemvalue window,1003,'If you want can write a full path that do not exits now '

return

/* ##258_1001.3 */
258_1001.3: /* Event Changed -   1001 */
Arg window self
destino=vpgetitemvalue(window,1001)
if verify(destino,XRANGE('!','z')||'')<>0 THEN
do
response=VpMessageBox(window,'Character don`t valid','Put another caracter only are valid characters 'XRANGE('!','z')||'' )
call vpsetitemvalue window, 1001,'' 
end
return

/* ##258_1002.0 */
258_1002.0: /* Event Clicked/selected - List Box  1002 */
Arg window self
call save_prog

return rutinas






/* ##258_1002.10 */
258_1002.10: /* Event Mouse move - Save and close  1002 */
Arg window self x y

call vpitem window,1003,'FORECOLORRGB','255'
call vpsetitemvalue window,1003,' '

return

/* ##258_1002.16 */
258_1002.16: /* Event List Box  1002, Mouse button 1 double click */
Arg window self

/*
cont=VpGetItemCount(window, 1002) /* numero de ficheros seleccionados*/
say cont 'cont' lista_files
value=VpItem(window,1002,'SENDMSG','0x01bf','-1','0') 
say value window 
indexes.0=cont
call lee_lista1002
index=1
*/
call VpGetItemValue window, 1020,"ALL","value." 
say value.0 value.1 value.2 value.cont

/*
index=VpGetIndex(window, 1000, 'FIRST') 
say index '444s4'

do i=1 to cont
say i value.i lista.i indexes.i
values=VpGetItemValue(window,1002,lista,i)
 
/*index.i=VpGetIndex(window,1002,'NEXT',0) */
/*lista.i=VpGetItemValue(window,1002,value.,i) */
/*index.=VpAddItem(window, 1002, 'LIST', 'lista.')*/
/*say index.i 'sasasas' lista.0 lista.1 lista.2*/
end /* end do */

**/














/*
valuedo=vpgetitemvalue(window,1002)
valuedo=valuedo||'\'
say valuedo
/*call sysfiletree valuedo,"lista","SO"*/
say index locs 'locs' lista.0 lista.1 lista.2
*/
/******
do i=1 to lista.0
value=lista.i
/*indexmas = vpadditem (window,1002,locs,lista.i)*/
/*index=VpAddItem(window, 1002, index, value) */
/*
SAY VALUE FILESPEC("PATH",VALUE) FILESPEC("name",VALUE)
NEWVAL=SUBSTR(FILESPEC("PATH",VALUE),1,50)||SPACE(5)|| FILESPEC("name",VALUE) 
*/
index=VpAddItem(window,1002,'ASCENDING', VALue) 
end /* end do */
*******/

/*
CALL VpDeleteItem window, 1002, 'ALL' 
do i=1 to index.0
 index=VpAddItem(mainwindow,1002,'ascending',lista.i) 
end /* end do */
/*repintarlos*/
*/
return

/* ##258_1002.9 */
258_1002.9: /* Event Key press - List Box  1002 */
Arg window self key isChar ctrl shft alt

return

/* ##258_1007.10 */
258_1007.10: /* Event Mouse move -   1007 */
Arg window self x y

call vpitem window,1003,'FORECOLORRGB','255'
call vpsetitemvalue window,1003,'The name similar to: MifileDats without .cmd '

return

/* ##258_1008.10 */
258_1008.10: /* Event Mouse move - Container  1008 */
Arg window self x y
/*call vpitem window,1003,'FORECOLORRGB','16711680' rojo*/
call vpitem window,1003,'FORECOLORRGB','255' /*azul*/
CALL VpSetItemValue window, 1003,' Double click for delete select' 



return

/* ##258_1008.16 */
258_1008.16: /* Event Mouse button 1 double click - Container  1008 */
Arg window self index
CALL VpDeleteItem window, 1008 , index

return

/* ##258_1009.10 */
258_1009.10: /* Event Mouse move - List Box  1009 */
Arg window self x y
call vpitem window,1003,'FORECOLORRGB','255'
call vpsetitemvalue window,1003,'Double click for delete path and files '

return

/* ##258_1009.16 */
258_1009.16: /* Event Mouse button 1 double click - List Box  1009 */
procedure expose window
Arg window self
/*eliminar el seleccionado*/
ind=VpGetIndex(window,1009,'SELECTED',index)
/*busca que se va a eliminar*/
valuedo=VpGetItemValue(window,1009) 
/*valuedo=valuedo||'\'*/
CALL VpDeleteItem window, 1009 , ind

/*quitar los ficheros a excluir que tienen la misma raiz que este*/
/*recoge la lista de files completa*/
borrar.0=0
call vpgetitemvalue window,1008,"ALL",value.

index=VpGetIndex(window,1008,'NEXT',0)

do i= 1 to value.0
indexes.i=index
value=VpGetItemValue(window,1008,index)
/* say substr(value,1,length(valuedo)) 'asaasasxx' valuedo*/
cortoval=substr(value,1,length(valuedo))
 if valuedo=cortoval then
 do
 /*eliminarlo*/
 borrar.i=index
 borrar.0=i
 end
indexes.0=i
index=VpGetIndex(window,1008,'NEXT',index)
end /* end do */

do i=1 to borrar.0
call vpdeleteitem window,1008,borrar.i
end /* end do */



return

/* ##258_1010.0 */
258_1010.0: /* Event Clicked/selected - Close without save  1010 */
Arg window self
CALL VpWindow window,'CLOSE' 

return

/* ##258_1010.10 */
258_1010.10: /* Event Mouse move - Close without save  1010 */
Arg window self x y
call vpitem window,1003,'FORECOLORRGB','255'
call vpsetitemvalue window,1003,''


return

/* ##258_1011.0 */
258_1011.0: /* Event Clicked/selected - Exclude files  1011 */
Arg window self

value=vpgetitemvalue(window,1009)
if value='' then
do
response=VpMessageBox(window,'Please select a valid path','You have not select any path for backup files')
end
else
do
value=VpOpenForm(window, 303, value)
mainwindow=window
end
return

/* ##258_FORM.1 */
258_FORM.1: /* Event Form events, Opened */
Arg window 


IF 'NOVALUE'=VpAppVariable('GET', MODICRE) THEN
DO
Call VpAppVariable 'SET', MODICRE, 'CREATION'
END
else
do
/*quiere decir que la ficha MODIFY esta open*/
/* no se pueden abrir las dos simultaneas*/
response=VpMessageBox(window,'Other form open!','For open the form creation, you have close the form modify')
CALL VpWindow window,'CLOSE' 
return
end



nameprog='default'
CALL VpSetItemValue window,1007,nameprog
/*call refresca_discos*/

rc=VpSetItemStyle(window, 1008, 'TEXT')

/* set window postion */
rc = SysIni(progini, "creationwin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end

return

/* ##258_Form.2 */
258_Form.2: /* Event Form events, Closed */
Arg window 


Call VpAppVariable 'SET', MODICRE, 'NOVALUE'
/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "creationwin", "mainpos", rc)

/* muestra todos los files actualiza el recien creado*/
filename=directory()||'\TheBacks\'
CALL VpDeleteItem mainhandle, 1000, 'ALL' 
CALL VpLoadFromFile mainhandle,1000,filename

return

/* ##301_1000.10 */
301_1000.10: /* Event Mouse move -   1000 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Select one ' 



return

/* ##301_1000.3 */
301_1000.3: /* Event Changed -   1000 */
procedure expose topic defaultvalue

Arg window self

/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'
CALL VpDeleteItem window,1001,'ALL'
/*
say topic 'topic'
say 'default' defaultvalue
*/
if topic \= '' then do
   defaultdrive = substr(topic,1,2)
   call SysFileTree topic||'\*', 'dirlist','do'
         end

if defaultdrive \= VpGetItemValue(window,1000) |,
      topic = '' |,
      DirList.0 = 0,
      then do

   /* Get item value 1000 Combo Box */
   seldrive = VpGetItemValue(window,1000)
   call SysFileTree seldrive||"\", 'dirlist','d'
   merkedir=seldrive||"\"

   do i=1 to dirlist.0
      abbruch=0
      do y=1 while abbruch=0
         slashpos=pos("\",subword(dirlist.i,y,1))
         if slashpos<>0 then do
            abbruch=1
            end
         end y
      pfad=subword(dirlist.i,y-1)
      pfad=substr(pfad,4)

      /* Add item sorted ascending 1002 List Box */
      index=VpAddItem(window, 1002,'ASCENDING',pfad)

      end i
      
   /* Get item value 1000 Combo Box */
   value = VpGetItemValue(window,1000)

   /* Set item value 1003 Entry Field */
   CALL VpSetItemValue window,1003,value
   end /* else do ... */

else do
   index=VpAddItem(window, 1002, 'END', "..")
   do i=1 to dirlist.0
      value = right(dirlist.i,length(dirlist.i)-3)
      index=VpAddItem(window, 1002, 'END', value)
      end i   
   CALL VpSetItemValue window,1003,topic
   topic = ''
   end /* else do */
return

/* ##301_1001.10 */
301_1001.10: /* Event Container  1001, Mouse move */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','16711680'
CALL VpSetItemValue window, 1007,' Push the key Ctrl, and mantein it push, for select' 


return

/* ##301_1002.0 */
301_1002.0: /* Event Clicked/selected - List Box  1002 */
Arg window self

/* Get item value 1000 Combo Box */
seldrive = VpGetItemValue(window,1000)

/* Get item value 1002 List Box */
seldir = VpGetItemValue(window,1002)

if seldir<>".." then do

komplett=seldrive||"\"||seldir

/* Set item value 1003 Entry Field */
CALL VpSetItemValue window,1003,komplett

end

return

/* ##301_1002.10 */
301_1002.10: /* Event Mouse move - List Box  1002 */
Arg window self x y


call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Push mouse click, or double click for select' 


return

/* ##301_1002.16 */
301_1002.16: /* Event Mouse button 1 double click - List Box  1002 */
Arg window self

komplett=VpGetItemValue(window,1003)

/* Get item value 1000 Combo Box */
seldrive = VpGetItemValue(window,1000)

/* Get item value 1002 List Box */
seldir = VpGetItemValue(window,1002)

/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'

if seldir<>".." then do

/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'END', '..')

call SysFileTree seldrive||"\"||seldir||"\*.*", 'dirlist','d'

do i=1 to dirlist.0

abbruch=0

do y=1 while abbruch=0
   slashpos=pos("\",subword(dirlist.i,y,1))
   if slashpos<>0 then do
      abbruch=1
      end
end

pfad=subword(dirlist.i,y-1)
pfad=substr(pfad,4)

/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'ASCENDING', pfad)

end

/* Give item focus 1002 List Box */
CALL VpItem window,1002,'FOCUS'
/* Select item 1002 List Box */
CALL VpSelect window,1002,1,1

end

else do
/* wenn man den .. anwhlt */

ende=0
merke=0
vergleich=""
test=komplett

do while ende<>1

slashpos=pos("\",test)
if slashpos<>0 then do
merke=slashpos
if vergleich<>"" then do
    vergleich=vergleich||"\"||substr(test,1,merke-1)
    end
    else do
    vergleich=vergleich||substr(test,1,merke-1)
    end
test=substr(test,merke+1)
end
else do
ende=1
end

end

/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'

if length(vergleich)>3 then do
/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'END', "..")
end

/* Set item value 1003 Entry Field */
CALL VpSetItemValue window,1003,vergleich

call SysFileTree vergleich||"\", 'dirlist','d'

do i=1 to dirlist.0

abbruch=0

do y=1 while abbruch=0
   slashpos=pos("\",subword(dirlist.i,y,1))
   if slashpos<>0 then do
      abbruch=1
      end
end

pfad=subword(dirlist.i,y-1)
pfad=substr(pfad,4)

/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'ASCENDING', pfad)

end

end
return

/* ##301_1003.10 */
301_1003.10: /* Event Mouse move -   1003 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Dont modify it' 



return

/* ##301_1003.3 */
301_1003.3: /* Event   1003, Changed */
Arg window self

value=vpgetitemvalue(window,1003)
/*CALL VpLoadFromFile window, 1001,value||'\'*/
rc=VpSetItemStyle(window, 1001,'TEXT')
CALL VpDeleteItem window, 1001, 'ALL' 


ruta=value||"\"
call SysFileTree ruta,"file","bo" /* files y directorios*/

/*
do index = 1 to file.0
if file.0=0 then loop
end /* end do */
*/

index=VpAddItem(window, 1001, 'LIST','file.')





return

/* ##301_1004.0 */
301_1004.0: /* Event Clicked/selected - ~Open  1004 */
Arg window self

CALL VpWindow window,'CLOSE'

return

/* ##301_1004.10 */
301_1004.10: /* Event Mouse move - ~Cancel  1004 */
Arg window self x y


call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Close without nothing' 


return

/* ##301_1005.10 */
301_1005.10: /* Event Mouse move -   1005 */
Arg window self x y
CALL VpItem window,1001,'SENDMSG','0x0347','1024',-30
return

/* ##301_1006.0 */
301_1006.0: /* Event Clicked/selected - ~Directory where do you put your  1006 */

procedure expose mainwindow
Arg window self

CALL VpWindow window,'CLOSE'

selectedpath=VpGetItemValue(window,1003)
miruta=selectedpath
if length(selectedpath)<3 then
do
selectedpath=""
end
else
do
selectedpath=right(selectedpath,length(selectedpath)-3)
end
/* Set item value 1002 Entry Field */
/*CALL VpSetItemValue mainwindow,1001,selectedpath*/
CALL VpSetItemValue mainwindow,1001,miruta



return

/* ##301_1006.10 */
301_1006.10: /* Event Mouse move - ~Directory where do you put your  1006 */
Arg window self x y


call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' This is the directory that you select for made the backup' 


return

/* ##301_1008.0 */
301_1008.0: /* Event Clicked/selected - ~Directory that do you select fo  1008 */

procedure expose mainwindow
/*say mainwindow 'mainw'*/
Arg window self
/*say self 'self2'*/
CALL VpWindow window,'CLOSE'

CALL VpGetIndex window,1001,'ALLSELECTED','INDEXES.' 
do i= 1 to indexes.0
value.i=vpgetitemvalue(window,1001,indexes.i)
value.0=i
/*index=VpAddItem(mainwindow,1009,'END',value.i)*/ 
/*say value.i 'vi'*/
end /* end do */


value=VpGetItemCount(window, 1001) /*cuenta el num registros*/
CALL VpGetIndex window,1001,'ALLSELECTED','INDEXES.' /*todos los seleccionados*/
if indexes.0=value then
do
/* si todos los registros seleccionados, coge solo la raiz*/
/*say 'todos  selec' indexes.0 value*/
raiz=vpgetitemvalue(window,1003)
if right(raiz,1)=':' then raiz=raiz||'\'
value.1=raiz
value.0=1
end
 
 
index=VpAddItem(mainwindow,1009,'LIST',VALUE.) 



return

/* ##301_1008.10 */
301_1008.10: /* Event Mouse move - ~Directory that do you select fo  1008 */
Arg window self x y


call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Your selected files' 


return

/* ##301_1009.0 */
301_1009.0: /* Event Clicked/selected - Select all  1009 */
Arg window self
CALL VpSelect window, 1001, 'ALL', 1 

return

/* ##301_1009.10 */
301_1009.10: /* Event Mouse move - Select all  1009 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Mark all records selected' 



return

/* ##301_1010.0 */
301_1010.0: /* Event Clicked/selected - Select nothing  1010 */
Arg window self
CALL VpSelect window, 1001, 'ALL', 0 

return

/* ##301_1010.10 */
301_1010.10: /* Event Mouse move - Select nothing  1010 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Unmark all records' 



return

/* ##301_1011.10 */
301_1011.10: /* Event Mouse move -   1011 */
Arg window self x y
CALL VpItem window,1001,'SENDMSG','0x0347','1024',30

return

/* ##301_FORM.1 */
301_FORM.1: /* Form events - Opened */
/*procedure expose topic */ /* anulado para ajustar la ventana*/
Arg window 
topic=getbootdrive() /*no siempre, esto se puede anular puesto que index=1*/
/* set window postion */
rc = SysIni(progini, "DDopenwin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end

/* WE GRAB THE INITIAL PATH FIRST FROM REFERING WINDOW */
defaultvalue = topic
topic=''
/* WE TAKE THE DEFAULT DRIVE LETTER FROM THE INITIAL PATH */
defaultdrive=substr(defaultvalue,1,3)

/* WE ASK FOR THE USED DRIVES ON THIS MACHINE */
driveslist=SysDriveMap("A:","USED")

do i=1 to words(driveslist)

if subword(driveslist,i,1)<>"B:" then do
/* Add item to end 1000 Combo Box */
index=VpAddItem(window, 1000, 'END', subword(driveslist,i,1))
end

end

/* Get index of value 1000 Combo Box */
index=VpGetIndex(window,1000,'SEARCH',substr(defaultdrive,1,2))

/* Select item 1000 Combo Box */
CALL VpSelect window,1000,index,1

return 


GetBootDrive: Procedure 
If \Rxfuncquery('SysBootDrive') Then
   bootdrive = SysBootDrive()       /* Object or Updated Classic Rexx */
Else
   Do
      If \Rxfuncquery('RxBootDrive') Then
         bootdrive = RxBootDrive()                        /* RxExtras */
      Else
         Do                       /* Examine various config.sys items */
            Parse Upper Value Value('PATH', ,'OS2ENVIRONMENT') ,
               With ':\OS2\SYSTEM' - 1 bootdrive + 2
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('RUNWORKPLACE', ,'OS2ENVIRONMENT'), 1, 2 )
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('COMSPEC', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('OS2_SHELL', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('SYSTEM_INI', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('USER_INI', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then                      /* no guesses */
               bootdrive = 0
         End
   End
Return bootdrive               /* Returns BootDrive, letter and colon */
/* ##301_Form.2 */
301_Form.2: /* Event Form events, Closed */
Arg window 
/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "DDopenwin", "mainpos", rc)


return

/* ##303_1000.10 */
303_1000.10: /* Event Mouse move -   1000 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Select one ' 



return

/* ##303_1000.3 */
303_1000.3: /* Event   1000, Changed */


return

/* ##303_1001.10 */
303_1001.10: /* Event Container  1001, Mouse move */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','16711680'
CALL VpSetItemValue window, 1007,' Push the key Ctrl, and mantein it push, for select' 


return

/* ##303_1002.0 */
303_1002.0: /* Event Clicked/selected - List Box  1002 */
Arg window self

/* Get item value 1000 Combo Box */
seldrive = VpGetItemValue(window,1000)

/* Get item value 1002 List Box */
seldir = VpGetItemValue(window,1002)

if seldir<>".." then do

komplett=seldrive||"\"||seldir
/*say komplett 'kom' seldrive 'seldri' seldir 'seldi'*/
/* Set item value 1003 Entry Field */
CALL VpSetItemValue window,1003,komplett

end

return

/* ##303_1002.10 */
303_1002.10: /* Event Mouse move - List Box  1002 */
Arg window self x y


call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Push mouse click, or double click for select' 


return

/* ##303_1002.16 */
303_1002.16: /* Event Mouse button 1 double click - List Box  1002 */
Arg window self
caminito= VpGetItemValue(window,1012)
komplett=VpGetItemValue(window,1003)
if vergleich='' then vergleich=caminito
if vergleich='vergleich' | vergleich='VERGLEICH' then vergleich=caminito
/*SAY VERGLEICH 'VERGGGGGG' TEST*/
/* Get item value 1000 Combo Box */
seldrive = VpGetItemValue(window,1000)
/* Get item value 1002 List Box */
seldir = VpGetItemValue(window,1002)
/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'
if seldir<>".." then do
/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'END', '..')
call SysFileTree seldrive||"\"||seldir||"\*.*", 'dirlist','d'

   do i=1 to dirlist.0
   abbruch=0
   do y=1 while abbruch=0
      slashpos=pos("\",subword(dirlist.i,y,1))
      if slashpos<>0 then do
         abbruch=1
         end
   end

   pfad=subword(dirlist.i,y-1)
   pfad=substr(pfad,4)

   /* Add item to end 1002 List Box */
   index=VpAddItem(window, 1002, 'ASCENDING', pfad)

   end

   /* Give item focus 1002 List Box */
   CALL VpItem window,1002,'FOCUS'
   /* Select item 1002 List Box */
   CALL VpSelect window,1002,1,1

end
else do
/*  subir un directorio, .. */

/*
say caminito 'caminito'
say komplett 'komplett'
say vergleich 'vergleich'
say test 'test'
*/
if length(komplett)=3 then komplett=komplett||'\'
   if caminito<>komplett then
   do  
   ende=0
   merke=0
   vergleich=""
   test=komplett

     do while ende<>1

     slashpos=pos("\",test)
     if slashpos<>0 then do
     merke=slashpos
     if vergleich<>"" then do
/*     say vergleich 'verg1'*/
              vergleich=vergleich||"\"||substr(test,1,merke-1)
/*     say vergleich 'verg2'              */
         end
         else do
         vergleich=vergleich||substr(test,1,merke-1)
/*     say vergleich 'verg3'         */
         end
     test=substr(test,merke+1)
     end
     else do
     ende=1
     end

     end
     
   end 
/*
     say vergleich 'verg4'
     say test 'test1'
*/     
/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'

if length(vergleich)>3 then do
/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'END', "..")
end

/* Set item value 1003 Entry Field */
/*say vergleich 'verg'*/
if vergleich='' then vergleich=caminito
if vergleich='vergleich' | vergleich='VERGLEICH' then vergleich=caminito
CALL VpSetItemValue window,1003,vergleich

call SysFileTree vergleich||"\", 'dirlist','d'
VERGLEICH=''
do i=1 to dirlist.0

abbruch=0

do y=1 while abbruch=0
   slashpos=pos("\",subword(dirlist.i,y,1))
   if slashpos<>0 then do
      abbruch=1
      end
end

pfad=subword(dirlist.i,y-1)
pfad=substr(pfad,4)

/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'ASCENDING', pfad)

end

end


return

/* ##303_1003.10 */
303_1003.10: /* Event Mouse move -   1003 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Dont modify it' 



return

/* ##303_1003.3 */
303_1003.3: /* Event   1003, Changed */
Arg window self

value=strip(vpgetitemvalue(window,1003))
/*say value length(value) 'value'*/
/*CALL VpLoadFromFile window, 1001,value||'\'*/
rc=VpSetItemStyle(window, 1001,'TEXT')
rc=VpSetItemStyle(window, 1001,'DETAILS')
rc=VpSetItemStyle(window, 1001,'NONFLOWED')
RC=VpSetItemStyle(window, 1001,'MINIICON')

Icon_carpeta = VpLoadPicture('RESICON',3001)
Icon_fichero= VpLoadPicture('RESICON',3000)




rc=VpSetItemStyle(window, 1001,'SPLITBAR',0,2000)
RC=VpSetItemStyle(window, 1001,'MINIICON')

CALL VpDeleteItem window, 1001, 'ALL' 
CALL VpDeleteItem window,1002,'ALL'



ruta=value||"\"
esruta=substr(ruta,3,4)
if esruta='\\' then
do
ruta=substr(ruta,1,3)
esruta=''
end
/*say ruta length(ruta) 'ruta'*/
call SysFileTree ruta,"file","fo" /* files */
RC=VpSetItemStyle(window, 1001,'MINIICON')
/*
do index = 0 to file.0
if file.0=0 then loop
end /* end do */
*/
/*index=VpAddItem(window, 1001, 'LIST','file.',icon_fichero)*/
    do i = 1 to file.0
    index=vpadditem(window,1001,'END',file.i,icon_fichero)
    end /* end do */
call SysFileTree ruta,"file","do" /* files */
RC=VpSetItemStyle(window, 1001,'MINIICON')
/*
do index = 0 to file.0
if file.0=0 then loop
end /* end do */
*/
/*index=VpAddItem(window, 1001, 'LIST','file.',icon_fichero)*/
    do i = 1 to file.0
    index=vpadditem(window,1001,'END',file.i,icon_carpeta)
    end /* end do */




/*quitar la letra de la unidad*/
if file.0='file.0' then file.0=0
file.0=file.0+1
do i=1 to file.0 by 1

   if i=1 then
   do
   newfile.1='..'
   end
   else
   do
   mas=i-1
   newfile.i=substr(file.mas,4,length(file.mas))
   newfile.0=i
   end
end /* end do */

index=VpAddItem(window,1002,'LIST','newfile.')






return

/* ##303_1004.0 */
303_1004.0: /* Event Clicked/selected - ~Open  1004 */
Arg window self

CALL VpWindow window,'CLOSE'

return

/* ##303_1004.10 */
303_1004.10: /* Event Mouse move - ~Cancel  1004 */
Arg window self x y


call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Close without nothing' 


return

/* ##303_1005.10 */
303_1005.10: /* Event Mouse move -   1005 */
Arg window self x y
CALL VpItem window,1001,'SENDMSG','0x0347','1024',-30
return

/* ##303_1008.0 */
303_1008.0: /* Event Clicked/selected - ~Directory that do you select fo  1008 */

procedure expose mainwindow
/*say mainwindow 'mainw'*/
Arg window self
/*say self 'self2'*/
CALL VpWindow window,'CLOSE'

call refresca_discos

CALL VpGetIndex window,1001,'ALLSELECTED','INDEXES.' 
do i= 1 to indexes.0
value.i=vpgetitemvalue(window,1001,indexes.i)
value.0=i
/*index=VpAddItem(mainwindow,1009,'END',value.i)*/ 
/*say value.i 'vi'*/
end /* end do */


value=VpGetItemCount(window, 1001) /*cuenta el num registros*/
CALL VpGetIndex window,1001,'ALLSELECTED','INDEXES.' /*todos los seleccionados*/
if indexes.0=value then
do
/* si todos los registros seleccionados, coge solo la raiz*/
/*say 'todos  selec' indexes.0 value*/
raiz=vpgetitemvalue(window,1003)
/*say raiz*/
if right(raiz,1)=':' then raiz=raiz||'\'
value.1=strip(raiz)
value.0=1
end
 
index=VpAddItem(mainwindow, MODIOCRE ,'LIST',VALUE.) 



return

/* ##303_1008.10 */
303_1008.10: /* Event Mouse move - ~Directory that do you select fo  1008 */
Arg window self x y


call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Your selected files' 


return

/* ##303_1009.0 */
303_1009.0: /* Event Clicked/selected - Select all  1009 */
Arg window self
CALL VpSelect window, 1001, 'ALL', 1 

return

/* ##303_1009.10 */
303_1009.10: /* Event Mouse move - Select all  1009 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Mark all records selected' 



return

/* ##303_1010.0 */
303_1010.0: /* Event Clicked/selected - Select nothing  1010 */
Arg window self
CALL VpSelect window, 1001, 'ALL', 0 

return

/* ##303_1010.10 */
303_1010.10: /* Event Mouse move - Select nothing  1010 */
Arg window self x y

call vpitem window,1007,'FORECOLORRGB','255'
CALL VpSetItemValue window, 1007,' Unmark all records' 



return

/* ##303_1011.10 */
303_1011.10: /* Event Mouse move -   1011 */
Arg window self x y
CALL VpItem window,1001,'SENDMSG','0x0347','1024',30

return

/* ##303_FORM.1 */
303_FORM.1: /* Form events - Opened */
procedure expose topic 
Arg window 
Call refresca_discos

/* si 1020=topic modificar*/
/* si 1008=topic creacion*/
/* set window postion */
rc = SysIni(progini, "DExcludewin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end

/*topic=getbootdrive()*/ /*no siempre, esto se puede anular puesto que index=1*/
CALL VpSetItemValue window,1012,topic

/* WE GRAB THE INITIAL PATH FIRST FROM REFERING WINDOW */
defaultvalue = topic
CALL VpSetItemValue window,1003,defaultvalue
value1=substr(defaultvalue,4,(length(defaultvalue)-2))
value2=filespec('path',defaultvalue)
files=filespec('name',defaultvalue)

topic=value1

/* WE TAKE THE DEFAULT DRIVE LETTER FROM THE INITIAL PATH */
defaultdrive=substr(defaultvalue,1,3)

/* WE ASK FOR THE USED DRIVES ON THIS MACHINE */
driveslist=SysDriveMap("A:","USED")

do i=1 to words(driveslist)

if subword(driveslist,i,1)<>"B:" then do
/* Add item to end 1000 Combo Box */
index=VpAddItem(window, 1000, 'END', subword(driveslist,i,1))
end

end

/* Get index of value 1000 Combo Box */
index=VpGetIndex(window,1000,'SEARCH',substr(defaultdrive,1,2))

/* Select item 1000 Combo Box */
CALL VpSelect window,1000,index,1

CALL VpDeleteItem window,1002,'ALL'
CALL VpSetItemValue window,1002,value1
 
return 



/* ##303_Form.2 */
303_Form.2: /* Event Form events, Closed */
Arg window 
/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "DExcludewin", "mainpos", rc)


return

/* ##263_Form.1 */
263_Form.1: /* Form events - Opened */
Arg window 

/* set window postion */
rc = SysIni(progini, "aboutwin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end
intro=x2c('0D0A')
tex="If you want translate the help file to other", 
" language, you can translate the backrar.htm file,", 
 " and send it to me."

CALL VpSetItemValue window,1001,tex 

return

/* ##263_Form.2 */
263_Form.2: /* Form events - Closed */
Arg window 
/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "aboutwin", "mainpos", rc)


return

/* ##256_1000.0 */
256_1000.0: /* Event Container  1000, Clicked/selected */
Arg window self index

value=VpGetItemValue(window,1000,index)

/* quita la seleccion por no ser un cmd */
if translate(right(value,3))<>"CMD" then
do
CALL VpSelect window, 1000, index, 0 
value=''
end

/* muestra los seleccionados*/
CALL VpGetIndex window,1000,'ALLSELECTED','INDEX.'  
do i=1 to index.0
/*say VpGetItemValue(window,1000,index.i)*/
/*aqui se pueden poner los seleccionados en la nueva ventana*/
end /* end do */

return

/* ##256_1000.16 */
256_1000.16: /* Event Mouse button 1 double click - Container  1000 */
Arg window self index
/*eliminarlo*/
response=VpMessageBox(window,'Delete the file?','Do you want delete the file?','YESNO')
if response='YES' then
do
value=VpGetItemValue(window,1000,index)
antes=directory()
actual=directory() || '\thebacks'
call directory actual
erase value
call directory antes
/* muestra todos los files actualiza el recien eliminado*/
filename=directory()||'\TheBacks\'
CALL VpDeleteItem mainhandle, 1000, 'ALL' 
CALL VpLoadFromFile mainhandle,1000,filename
end


return

/* ##256_1000.7 */
256_1000.7: /* Event Popup menu - Container  1000 */
Arg window self index
/****anulada la opcion por que al tenerlo abierto no se puede usar y daria problemas*/
/*
value=VpGetItemValue(window,1000,index)

antes=directory()
actual=directory() || '\thebacks'
call directory actual

e.exe value

call directory antes
*/
return

/* ##256_1002.0 */
256_1002.0: /* Event Clicked/selected - Close  1002 */
Arg window self
CALL VpWindow window,'CLOSE' 

return

/* ##256_1003.0 */
256_1003.0: /* Event Clicked/selected - Make backup of selected files  1003 */
Arg window self
CALL VpGetIndex window,1000,'ALLSELECTED','INDEX.'
if index.0='INDEX.0' then index.0=0
do i= 1 to index.0 by 1
prog.i=vpgetitemvalue(window,1000,index.i)
prog.0=i
/*say prog.i*/
end /* end do */
antes=directory()
actual=directory() || '\thebacks'
call directory actual

if prog.0='PROG.0' then prog.0=0
do i = 1 to prog.0 by 1
/*CALL VpLoadFromFile window,1000,'FOLDERS',prog.i*/
/*'cmd.exe /C' actual || '\' || prog.i*/
n=0
   do while n=0
   call beep 20000,100
   a=1
   if a=1 then
      do
      start prog.i
      n=1
      end
      else
      do
      a=0
      end
   end /* end do */

end /* end do */

call directory antes

return

/* ##256_1004.0 */
256_1004.0: /* Event Modify selected program  1004, Clicked/selected */
Arg window self
CALL VpGetIndex window,1000,'ALLSELECTED','INDEX.'
if index.0=1 then
do
/* Get item value 1000 Entry Field */
nameprog = VpGetItemValue(window,1000)

value=VpOpenForm(window, 257, value)
end
else
/*solo se puede seleccionar un fichero a modificar*/
do
response=VpMessageBox(window,'Error selection','You only can select one file, for modify')
end



return

/* ##256_1006.0 */
256_1006.0: /* Event Clicked/selected - Create one  1006 */
Arg window self
value=VpOpenForm(window, 258, value)


return

/* ##256_1007.0 */
256_1007.0: /* Event Clicked/selected - Rar values  1007 */
Arg window self

value=VpOpenForm(window, 259, value)
return

/* ##256_1008.0 */
256_1008.0: /* Event Clicked/selected - text  1008 */
Arg window self
value=VpOpenForm(window, 261, value)


return

/* ##256_260.0 */
256_260.0: /* Menu events - ~Ayuda Spanish */
Arg window self
view backrar.inf

return

/* ##256_261.0 */
256_261.0: /* Menu events - ~Help */
Arg window self
value=VpOpenForm(window, 263, value)

return

/* ##256_262.0 */
256_262.0: /* Menu events - ~About */
Arg window self
value=VpOpenForm(window, 262, value)

return

/* ##256_FORM.1 */
256_FORM.1: /* Event Form events, Opened */
Arg window 
mainhandle = window
/* set programm info text*/
crlf = '0d0a'x
/* init rexxutil */
rc = RxFuncAdd('SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs')
call SysLoadFuncs
Call VpAppVariable 'SET', MODICRE, 'NOVALUE'

Icon_fichero       = Vploadpicture('RESICON',3000)
Icon_CARPETA = Vploadpicture('RESICON',3001)
/* check debug mode */
/*
debugmode = SysIni(progini, "options", "debugmode",1)
say debugmode length(debugmode)
if debugmode = 1 then call vpwindow window,'ENABLESTDIO'
else call VpWindow window, 'DISABLESTDIO'
*/
call VpWindow window, 'DISABLESTDIO'
/*call vpwindow window,'ENABLESTDIO'*/


/*call VpWindow window, 'DISABLESTDIO'*/
ruta=directory()"\TheBacks"

call SysFileTree ruta,"file","d"
do index = 0 to file.0
if file.0=0 then 
do
mkdir directory()"\TheBacks"
end
end /* end do */
/* init the program ini*/
progini = directory()"\"||backrar.ini

/* set window postion */
rc = SysIni(progini, "mainwin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end

/* muestra todos los files*/
/*CALL VpGetIndex window,1000,'ALLSELECTED','INDEX.'  */
filename=directory()||'\TheBacks\'
CALL VpLoadFromFile window,1000,filename


return

/* ##256_Form.2 */
256_Form.2: /* Event Form events, Closed */
Arg window 
/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "mainwin", "mainpos", rc)

return

/* ##257_1000.0 */
257_1000.0: /* Event Clicked/selected - Search directory  1000 */
Arg window self

value=VpOpenForm(window, 301, value)
mainwindow=window
return

/* ##257_1002.0 */
257_1002.0: /* Event Clicked/selected - List Box  1002 */
Arg window self

call save_prog


return






/* ##257_1002.16 */
257_1002.16: /* Event List Box  1002, Mouse button 1 double click */
Arg window self

/*
cont=VpGetItemCount(window, 1002) /* numero de ficheros seleccionados*/
say cont 'cont' lista_files
value=VpItem(window,1002,'SENDMSG','0x01bf','-1','0') 
say value window 
indexes.0=cont
call lee_lista1002
index=1
*/
call VpGetItemValue window, 1020,"ALL","value." 
say value.0 value.1 value.2 value.cont

/*
index=VpGetIndex(window, 1000, 'FIRST') 
say index '444s4'

do i=1 to cont
say i value.i lista.i indexes.i
values=VpGetItemValue(window,1002,lista,i)
 
/*index.i=VpGetIndex(window,1002,'NEXT',0) */
/*lista.i=VpGetItemValue(window,1002,value.,i) */
/*index.=VpAddItem(window, 1002, 'LIST', 'lista.')*/
/*say index.i 'sasasas' lista.0 lista.1 lista.2*/
end /* end do */

**/














/*
valuedo=vpgetitemvalue(window,1002)
valuedo=valuedo||'\'
say valuedo
/*call sysfiletree valuedo,"lista","SO"*/
say index locs 'locs' lista.0 lista.1 lista.2
*/
/******
do i=1 to lista.0
value=lista.i
/*indexmas = vpadditem (window,1002,locs,lista.i)*/
/*index=VpAddItem(window, 1002, index, value) */
/*
SAY VALUE FILESPEC("PATH",VALUE) FILESPEC("name",VALUE)
NEWVAL=SUBSTR(FILESPEC("PATH",VALUE),1,50)||SPACE(5)|| FILESPEC("name",VALUE) 
*/
index=VpAddItem(window,1002,'ASCENDING', VALue) 
end /* end do */
*******/

/*
CALL VpDeleteItem window, 1002, 'ALL' 
do i=1 to index.0
 index=VpAddItem(mainwindow,1002,'ascending',lista.i) 
end /* end do */
/*repintarlos*/
*/
return

/* ##257_1002.9 */
257_1002.9: /* Event Key press - List Box  1002 */
Arg window self key isChar ctrl shft alt

return

/* ##257_1008.3 */
257_1008.3: /* Event   1008, Changed */
Arg window self
  
value = VpGetItemValue(window,1008)
if nuevo_disco=1 then
do
response=VpMessageBox(window,'Unidad no encontrada  'es_disco_crea,'Se aadira este disco a los disponibles, pero ten en cuenta que ahora no esta disponible')
nuevo_disco=0
end



return

/* ##257_1009.16 */
257_1009.16: /* Event Mouse button 1 double click - List Box  1009 */
procedure expose window
Arg window self
/*eliminar el seleccionado*/
index=VpGetIndex(window,1009,'SELECTED',index)
/*busca que se va a eliminar*/
valuedo=VpGetItemValue(window,1009) 
/*valuedo=valuedo||'\'*/
/*SAY 'VALUEDO' VALUEDO*/
/*eliminarlo*/

/*recoge la lista de files completa*/
call vpgetitemvalue window,"LISTA_FILES","ALL",value.
/*say value.0 value.1 value.2*/
ii=0
elimi.0=0
do i=1 to value.0
/*say value.i i substr(value.i,1,length(valuedo)) VALUEDO*/
	if valuedo=substr(value.i,1,length(valuedo)) then
	do
	/*indices a eliminar*/
	ii=ii+1
	elimi.ii=i ;elimi.0=ii
	/*say value.i i ii	*/
	end

end /* end do */

if ii<>0 then
do
  do i=elimi.0 to 1 by -1
  /*say elimi.i    */  
  CALL VpDeleteItem window, 1020 , elimi.i
  end /* end do */
end

CALL VpDeleteItem window, 1009 , index

return

/* ##257_1010.0 */
257_1010.0: /* Event Clicked/selected - Close without save  1010 */
Arg window self
CALL VpWindow window,'CLOSE' 

return

/* ##257_1011.0 */
257_1011.0: /* Event Clicked/selected - Exclude files  1011 */
Arg window self


value=vpgetitemvalue(window,1009)
if value='' then
do
response=VpMessageBox(window,'Please select a valid path','You have not select any path for backup files')
end
else
do

value=VpOpenForm(window, 303, VALUE)
mainwindow=window
end
return

/* ##257_1020.16 */
257_1020.16: /* Event Mouse button 1 double click - List Box LISTA_FILES = 1020 */
Arg window self
/*eliminar el seleccionado*/
CALL VpGetIndex window,1020,'ALLSELECTED','INDEXES.' 
/*recoge la lista de files completa*/
call vpgetitemvalue window,1020,"ALL",value.
/*say value.0 value.1 value.2*/
ii=0
elimi.0=0
do i=1 to value.0
	/*indices a eliminar*/
	If indexes.0>=i then
	do
	ii=ii+1
	elimi.ii=indexes.i ;elimi.0=ii
	/*say value.i i ii	*/
	end
end /* end do */

if ii<>0 then
do
  do i=elimi.0 to 1 by -1
  /*say elimi.i    */  
  CALL VpDeleteItem window, 1020 , elimi.i
  end /* end do */
end

return

/* ##257_FORM.1 */
257_FORM.1: /* Event Form events, Opened */
Arg window 

CALL VpSetItemValue window,1007,nameprog

IF 'NOVALUE'=VpAppVariable('GET', MODICRE) THEN
DO
Call VpAppVariable 'SET', MODICRE, 'MODIFY'
END
else
do
/*quiere decir que la ficha creacion esta open*/
/* no se pueden abrir las dos simultaneas*/
response=VpMessageBox(window,'Other form open!','For open the form modify, you have close creation')
CALL VpWindow window,'CLOSE' 
return
end


/* set window postion */
rc = SysIni(progini, "modifywin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end

call lee_prog
return

/* ##257_Form.2 */
257_Form.2: /* Event Form events, Closed */
Arg window 

Call VpAppVariable 'SET', MODICRE, 'NOVALUE'

/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "modifywin", "mainpos", rc)

/* muestra todos los files actualiza el recien creado*/
filename=directory()||'\TheBacks\'
CALL VpDeleteItem mainhandle, 1000, 'ALL' 
CALL VpLoadFromFile mainhandle,1000,filename

return

/* ##259_1002.0 */
259_1002.0: /* Event Clicked/selected - Close  1002 */
Arg window self
CALL VpWindow window,'CLOSE' 

return

/* ##259_1009.0 */
259_1009.0: /* Event Clicked/selected - text  1009 */
Arg window self
NAME=VPGETITEMVALUE(WINDOW,1000)
 call SysIni  'H:\BACKRAR\MYAPP.INI', 'NAME', name /* Save the value        */
 say  SysIni( 'H:\BACKRAR\MYAPP.INI', 'NAME')      /* Query the value       */
 /*call SysIni , 'MYAPP'*/               /* Delete all MYAPP info */
 EXIT

return

/* ##259_FORM.1 */
259_FORM.1: /* Event Form events, Opened */
Arg window 
/* set window postion */
rc = SysIni(progini, "rarvalueswin", "mainpos")
if rc >< 'ERROR:' then do
parse var rc xpos ':' ypos ':' xsize ':' ysize
CALL VpWindow window,'SETPOS', xpos, ypos, xsize, ysize
end

/* set default doc infos */
rarprog = SysIni(progini, "rarvalues", "rarprog")
if rarprog = "ERROR:" then rarprog = ""
call VpSetItemValue window, 1000, rarprog
compres = SysIni(progini, "rarvalues", "compres")
if compres = "ERROR:" then compres = ""
call VpSetItemValue window, 1001, compres
properti = SysIni(progini, "rarvalues", "properti")
if properti = "ERROR:" then properti = ""
call VpSetItemValue window, 1003, properti


return

/* ##259_FORM.2 */
259_FORM.2: /* Event Form events, Closed */
Arg window 
/* save window position*/
parse value VpWindow(window,"GETSIZE") with xsize ysize
parse value VpWindow(window,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "rarvalueswin", "mainpos", rc)

/*recoge valores de pantalla*/
program=VpGetItemValue(window,1000) 
compres=VpGetItemValue(window,1001) 
properti=VpGetItemValue(window,1003)  

rc=SysIni(progini,"rarvalues","rarprog",program)
rc = SysIni(progini, "rarvalues", "compres", compres)
rc = SysIni(progini, "rarvalues", "properti",properti)


return

/* ##302_1000.3 */
302_1000.3: /* Event Changed -   1000 */
procedure expose topic

Arg window self

/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'

if topic \= '' then do
   defaultdrive = substr(topic,1,2)
   call SysFileTree topic||'\*', 'dirlist','do'
   end

if defaultdrive \= VpGetItemValue(window,1000) |,
      topic = '' |,
      DirList.0 = 0,
      then do

   /* Get item value 1000 Combo Box */
   seldrive = VpGetItemValue(window,1000)
   call SysFileTree seldrive||"\", 'dirlist','do'
   merkedir=seldrive||"\"

   do i=1 to dirlist.0
      abbruch=0
      do y=1 while abbruch=0
         slashpos=pos("\",subword(dirlist.i,y,1))
         if slashpos<>0 then do
            abbruch=1
            end
         end y
      pfad=subword(dirlist.i,y-1)
      pfad=substr(pfad,4)

      /* Add item sorted ascending 1002 List Box */
      index=VpAddItem(window, 1002,'ASCENDING',pfad)

      end i
      
   /* Get item value 1000 Combo Box */
   value = VpGetItemValue(window,1000)

   /* Set item value 1003 Entry Field */
   CALL VpSetItemValue window,1003,value
   end /* else do ... */

else do
   index=VpAddItem(window, 1002, 'END', "..")
   do i=1 to dirlist.0
      value = right(dirlist.i,length(dirlist.i)-3)
      index=VpAddItem(window, 1002, 'END', value)
      end i   
   CALL VpSetItemValue window,1003,topic
   topic = ''
   end /* else do */
return

/* ##302_1001.0 */
302_1001.0: /* Event Clicked/selected - ~Open  1001 */
procedure expose mainwindow
Arg window self

CALL VpWindow window,'CLOSE'

selectedpath=VpGetItemValue(window,1003)
miruta=selectedpath
if length(selectedpath)<3 then
do
selectedpath=""
end
else
do
selectedpath=right(selectedpath,length(selectedpath)-3)
end
/* Set item value 1002 Entry Field */
CALL VpSetItemValue mainwindow,1001,selectedpath



return

/* ##302_1002.0 */
302_1002.0: /* Event Clicked/selected - List Box  1002 */
Arg window self

/* Get item value 1000 Combo Box */
seldrive = VpGetItemValue(window,1000)

/* Get item value 1002 List Box */
seldir = VpGetItemValue(window,1002)

/*seldira=vpgetitemvalue(window,1002,2)*/
/*say seldir 'seldir' filespec('path',seldrive'\'||seldir) 'aaa' seldira*/
if seldir<>'seldir' then
do
	if seldir<>".." then do
	komplett=seldrive||filespec('path',seldrive'\'||seldir)
	/* Set item value 1003 Entry Field */
	CALL VpSetItemValue window,1003,komplett
	end
end
return

/* ##302_1002.16 */
302_1002.16: /* Event Mouse button 1 double click - List Box  1002 */
Arg window self

komplett=VpGetItemValue(window,1003)

/* Get item value 1000 Combo Box */
seldrive = VpGetItemValue(window,1000)

/* Get item value 1002 List Box */
seldir = VpGetItemValue(window,1002)

/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'

if seldir<>".." then do

/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'END', '..')

call SysFileTree seldrive||"\"||seldir||"\*.*", 'dirlist','d'

do i=1 to dirlist.0

abbruch=0

do y=1 while abbruch=0
   slashpos=pos("\",subword(dirlist.i,y,1))
   if slashpos<>0 then do
      abbruch=1
      end
end

pfad=subword(dirlist.i,y-1)
pfad=substr(pfad,4)

/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'ASCENDING', pfad)

end

/* Give item focus 1002 List Box */
CALL VpItem window,1002,'FOCUS'
/* Select item 1002 List Box */
CALL VpSelect window,1002,1,1

end

else do
/* wenn man den .. anwhlt */

ende=0
merke=0
vergleich=""
test=komplett

do while ende<>1

slashpos=pos("\",test)
if slashpos<>0 then do
merke=slashpos
if vergleich<>"" then do
    vergleich=vergleich||"\"||substr(test,1,merke-1)
    end
    else do
    vergleich=vergleich||substr(test,1,merke-1)
    end
test=substr(test,merke+1)
end
else do
ende=1
end

end

/* Delete all items 1002 List Box */
CALL VpDeleteItem window,1002,'ALL'

if length(vergleich)>3 then do
/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'END', "..")
end

/* Set item value 1003 Entry Field */
CALL VpSetItemValue window,1003,vergleich

call SysFileTree vergleich||"\", 'dirlist','d'

do i=1 to dirlist.0

abbruch=0

do y=1 while abbruch=0
   slashpos=pos("\",subword(dirlist.i,y,1))
   if slashpos<>0 then do
      abbruch=1
      end
end

pfad=subword(dirlist.i,y-1)
pfad=substr(pfad,4)

/* Add item to end 1002 List Box */
index=VpAddItem(window, 1002, 'ASCENDING', pfad)

end

end
return

/* ##302_1002.7 */
302_1002.7: /* Event Popup menu - List Box  1002 */
Arg window self

say 'poup'
return

/* ##302_1004.0 */
302_1004.0: /* Event Clicked/selected - ~Open  1004 */
Arg window self

CALL VpWindow window,'CLOSE'

return

/* ##302_1005.0 */
302_1005.0: /* Event Clicked/selected - ~Directory input  1005 */
procedure expose mainwindow
Arg window self

CALL VpWindow window,'CLOSE'

selectedpath=VpGetItemValue(window,1003)
miruta=selectedpath

index=VpAddItem(mainwindow, 1009,'ASCENDING',miruta)

/*busca y aade todos los files de esta ruta*/
call sysfiletree miruta||"\","value", "FSO" /* muestra solo ficheros, todos*/
/*index=VpAddItem(mainwindow,1002,'END',lista.i) */

/*CALL VpSprSht mainwindow, 1012, 'CLEARALL' */
/*CALL VpSprSht mainwindow, 1012, "SETNUMCELLS",2, value.0*/
/*say 'columns' 2 'files' value.0*/
rc=VpSetItemStyle(MAINwindow, 1008, 'TEXT')
/*rc=VpSetItemStyle(MAINwindow, 1008, 'DETAILS')*/
/*rc=VpSetItemStyle(mainwindow,1008,'COLNAME',1,' File name') */

cells.0=2 /*columnas*/
cells.1=value.0 /*filas*/
/****
do i=1 to value.0
n=i
cells.1.n=i
cells.2.n=value.i
/*
intro=x2c('0D0A')
value=value intro value.i
*/
/*say i value.i*/
/*index.i=vpadditem(mainwindow,1020,'END',value.i)*/
/*index=vpadditem(mainwindow,1008,'END',value.i)*/
/*
CALL VpSprSht mainwindow, 1012, 'SETCELL', 1, i, i
CALL VpSprSht mainwindow, 1012, 'SETCELL', 2, i, value.i
*/
/*if i>11000 then leave*/
 
end /* end do */
****/
/*CALL VpSprSht mainwindow, 1012, "SETROWLABELWIDTH", 12*/
/*CALL VpSprSht mainwindow, 1012, "SETHEADERHEIGHT", 'ruta seguir'*/
/*CALL VpSprSht mainwindow, 1012, "SETCELLWIDTH", 9*/
/*CALL VpSprSht mainwindow, 1012, 'SETCOLWIDTH', 2, 200*/

/*index=vpadditem(mainwindow,1008,'END',value)*/
/*stop CALL VpSprSht mainwindow, 1012, 'SETCELLS', cells.,0,0*/
/*mival=VpAddItem(mainwindow, 1020, 'LIST', 'VALUE.') *//* falla con mas de 32768 records*/
/*index=VpAddItem(mainwindow, 1008, 'LIST', 'VALUE.')*/
n=0 ; b=0 ; c=0; d=0
vala.0=0;valb.0=0;valc.0=0;vald.0=0

DO I=1 TO VALUE.0
/*say i 'ii'*/
select
 when i<30000 then
 do
 n=n+1
 vala.0=n
 valA.n=value.i
 /*say val.n 'i' i*/
 end
 when i>29998 & i<60000 then
 do
 b=b+1
/* say 'b' b 'i' i*/
 valb.0=b
 valB.b=value.i
 end
 when i>59998 & i<90000 then
 do
 c=c+1
/*  say 'c' c 'i' i*/
 valc.0=c
 valC.c=value.i
 end
 when i>90000 then
 do
 d=d+1
/*  say 'd' d 'i' i*/
 vald.0=d
 valD.d=value.i
 end
 otherwise
 say 'que raro' i
 end
END

index=VpAddItem(mainwindow, 1008, 'LIST', 'VALa.')
/*say 'a' vala.0 vala.1*/
if valb.0<>0 then
do
index=VpAddItem(mainwindow, 1008, 'LIST', 'VALb.')
end

/*say 'b' valb.0 valb.1*/
if valc.0 <>0 then
do
index=VpAddItem(mainwindow, 1008, 'LIST', 'VALc.')
end
/*say 'c' valc.0 valc.1*/
if vald.0<>0 then
do
index=VpAddItem(mainwindow, 1008, 'LIST', 'VALd.')
end
/*say 'd'  vald.0 vald.1*/

return

/* ##302_FORM.1 */
302_FORM.1: /* Form events - Opened */
procedure expose topic
Arg window 

/* WE GRAB THE INITIAL PATH FIRST FROM REFERING WINDOW */
defaultvalue = topic

/* WE TAKE THE DEFAULT DRIVE LETTER FROM THE INITIAL PATH */
defaultdrive=substr(defaultvalue,1,3)

/* WE ASK FOR THE USED DRIVES ON THIS MACHINE */
driveslist=SysDriveMap("A:","USED")

do i=1 to words(driveslist)

if subword(driveslist,i,1)<>"B:" then do
/* Add item to end 1000 Combo Box */
index=VpAddItem(window, 1000, 'END', subword(driveslist,i,1))
end

end

/* Get index of value 1000 Combo Box */
index=VpGetIndex(window,1000,'SEARCH',substr(defaultdrive,1,2))

/* Select item 1000 Combo Box */
CALL VpSelect window,1000,1,1

return

/* ##260_FORM.1 */
260_FORM.1: /* Event Form events, Opened */
Arg window 

h_tab = window

h_wc=VpOpenForm(window, 259, "dummy")
call VpAddItem window, 1000, 'Rarvalues', h_wc

h_copywave=VpOpenForm(window, 257, "dummy")
call VpAddItem window, 1000, 'Modify', h_copywave

return

/* ##260_FORM.2 */
260_FORM.2: /* Event Form events, Closed */
Arg window 

call VpWindow h_wc, 'CLOSE'
call VpWindow h_copywave, 'CLOSE'

return

/* ##SUB_lee_lista1002 */
lee_lista1002: /* lee el fichero programa */

Arg newwindow self
/*aceramiento del listado de unidades*/

say value newwindow window 
/*value=VpGetItemValue(newwindow, 1002, 'TABTEXT', 1) */
say value

return

/* ##SUB_LEE_PROG */
LEE_PROG: /* lee el fichero programa */

/*Arg window self*/
/*aceramiento del listado de unidades*/
/*usado por modify*/

datafile=directory()||'\TheBacks\'||nameprog
k=0;kc=0
DO WHILE LINES(DATAFILE)
La=LINEIN(datafile)
  Select
      When pos('NAMEPROG=',TRANSLATE(La))<>0 then
         do
         /*
         dif=length(La)-9 /* 9 es length de nameprog=*/
         es_nameprog=translate(left(right(la,dif),dif)) 
         */
         poss= pos('"',La)+1
         lastp= lastpos('"',La) - poss
           if poss=0 | lastp=0 then es_nameprog=''
           else
           do
           es_nameprog=substr(La,poss,lastp)
           end
         CALL VpSetItemValue window, 1007,es_nameprog 
         end
      When pos('SYSTEMPFILENAME',translate(La))<>0 then
         do
         poss= pos("'",La)+1
         lastp= lastpos("\",La) - poss
           if poss=0 | lastp=0 then destino=''
           else
           do
           destino=substr(La,poss,lastp)
           CALL VpSetItemValue window, 1001,destino 
           poss=0 ; lastp=0
           end
         
         end
      When pos('POSITIV',TRANSLATE(La))<>0 Then
         do
           if K=0 then
           do
           poss= pos('"',La)+1
           lastp=lastpos('"',La) - poss
           /*say poss 'poss' lastp 'lastp' la*/
           posito=substr(La,poss,lastp)   
/*           say posito 'posito' 'la' la      */
           index=VpAddItem(window, 1009, 'END', posito)
           La=LINEIN(datafile)
           k=1
           /*say pos('"',La) 'pos la' la 'k' k   */
             do while pos('"',La)=1
             /*say 'apa' la*/
             poss=pos('"',La)+1
             lastp=lastpos('"',La) - poss
             posito=substr(La,poss,lastp)
             index=VpAddItem(window, 1009, 'END', posito)
             /*say posito 'posito2'*/
             La=LINEIN(datafile)
             end /* end do */

           end
         k=1; poss=0 ; lastp=0
         end
      When pos('NEGATIV',TRANSLATE(La))<>0 Then
         do
           if KC=0 then
           do
           poss= pos('"',La)+1
           lastp=lastpos('"',La) - poss
/*           say poss 'poss' lastp 'lastp' la*/
                if poss=1 & lastp=-1 then posito=''
                else
		do
                posito=substr(La,poss,lastp)   
                end
                /*say posito 'posito' 'la' la      */
                index=VpAddItem(window, LISTA_FILES, 'END', posito)
           La=LINEIN(datafile)
           kC=1
           /*say pos('"',La) 'pos la' la 'k' k   */
             do while pos('"',La)=1
             poss=pos('"',La)+1
             lastp=lastpos('"',La) - poss
             posito=substr(La,poss,lastp)
             index=VpAddItem(window, LISTA_FILES, 'END', posito)
             /*say posito 'posito2'*/
             La=LINEIN(datafile)
             end /* end do */

           end
         kc=1; poss=0 ; lastp=0
         end
         
         
      Otherwise
  End
     
END /*do*/
call LINEOUT (datafile)

return

/* ##SUB_lee_rar */
lee_rar: /* lee el fichero programa */
/* usado por Rarvalues-open,*/
/*Arg window self*/
/*
filename=directory()||'\'||rarval.txt
valuete = CHARIN(filename,1,CHARS(filename))
rc=STREAM(filename,'c','close')
say valuete
say valuete.1 valuete.2 valuete.0
*/

lc=0
filename=directory()||'\'||rarval.txt
If Length(FileName) > 0 Then
   Do
      Do While Lines(FileName)
      lc=lc+1
      rar.lc=LineIn(FileName)
      End
      rar.0=lc
      rc=Stream(FileName,'c','close')
   End
   

return rar.lc

/* ##SUB_refresca_discos */
refresca_discos: /* Event   1008, Changed */

/*Arg window self*/
/*usado por DIRECTORYEXCLUDE*/


modiocre=VpAppVariable('GET', MODICRE) 
if modiocre='MODIFY' then modiocre=1020
if modiocre='CREATION' then modiocre=1008

return modiocre

/* ##SUB_save_marcados */
save_marcados: /* Event    */

/*Arg window self*/
/*aceramiento del listado de unidades*/


CALL VpGetIndex window,1002,'ALLSELECTED','INDEXES.' 
return

/* ##SUB_save_prog */
save_prog: /* Event   1008, Changed */

/*Arg window self*/
/*gravar con la creacion o modificacion del nuevo porg*/
/*usado por MODIFY Y CREATION*/
call refresca_discos

intro=x2c('0D0A')
i=0
Lin.0=0
newi=0
/*recoger datos a crear*/
nameprog=vpgetitemvalue(window,1007)
/*say nameprog length(nameprog)*/
savein=vpgetitemvalue(window,1001)
/*say savein*/

/*verificar la entrada correcta de datos*/
if nameprog = "" then
do
response=VpMessageBox(window,'Error in name program!','The name of program can not be null')
return
end
else
do
	if length(nameprog)<7 then
	do
	
	end
	

end


if savein = "" then
do
response=VpMessageBox(window,'Error in save in path!','The name of the path can not be null')
return
end
if substr(savein,length(savein),1)='\' then
do
savein=substr(savein,1,length(savein)-1)
end


/*verificar si existe el fichero a crear*/
/***quitar solo para modificar**ini**/
newp=directory()||"\TheBacks\"||nameprog||".cmd"
if modiocre='1008' then 
do
    
     /*say newp 'newp'*/
     call SysFileTree newp,"file","f"
     do index = 0 to file.0
       if file.0 >< 0 then 
       do
       response=VpMessageBox(window,'This program is repeat!!','Select a diferent name for your program, found this program in:' newp)
       return
       end /* end do */
     end
end     
/***quitar solo para modificar**fin**/

/*incluir ficheros list books*/
regn=VpGetItemCount(window, 1009) 
do i= 1 to regn
incluir.i=vpgetitemvalue(window,1009,i)
incluir.0=i
/*say incluir.i*/
end /* end do */

/*excluir ficheros container*/
regn=VpGetItemCount(window,modiocre)
/*say regn '1008'*/
CALL VpSelect window,modiocre, 'ALL', 1  
CALL VpGetIndex window,modiocre,'ALLSELECTED','INDEXES.' 
do i= 1 to regn
excluir.i=vpgetitemvalue(window,modiocre,indexes.i)
excluir.0=i
end 
if regn=0 then
do
excluir.0=0
excluir.1=''
end

/*SAY excluir.0 excluir.1 excluir.2*/

/*leer los datos basicos del inirar*/
rarprog = SysIni(progini, "rarvalues", "rarprog")
if rarprog = "ERROR:" then rarprog = ""
compres = SysIni(progini, "rarvalues", "compres")
if compres = "ERROR:" then compres = ""
properti = SysIni(progini, "rarvalues", "properti")
if properti = "ERROR:" then properti = ""

if rarprog='' | compres="" | properti="" then
do
response=VpMessageBox(window,'The compressor program need more values','(the program will be created but do not work ok) Do you want continue? ','YESNO')
end

if response='NO' then return /* retorna a la ficha de nuevo */
/*YES - continuar */
/* generar el fichero *.cmd */

Lin.1="/*"nameprog".cmd*/"
Lin.2="nameprog="'"'nameprog'"'
Lin.3="call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'"
Lin.4="call SysLoadFuncs"
Lin.5="signal on error"
newp=directory()||"\TheBacks\"||nameprog||".cmd"
namecorto=nameprog
if length(nameprog)>5 then
do
namecorto=substr(nameprog,1,5)
end
Lin.6="A_CREAR = SYSTEMPFILENAME('" || savein || "\" || namecorto || "???')"
Lin.7="intro=x2c('0D0A')"
Lin.8=""
Lin.9="mkdir A_CREAR"
do i=10 to 19
Lin.i=""
end /* end do */

Lin.20="if rc=0 then"
Lin.21="do"
newi=22
mas='||'
if incluir.0='INCLUIR.0' then incluir.0=0
if incluir.0=0 then
do
/*no se generara nada por no tener datos*/
response=VpMessageBox(window,'Error, no select','There are not nothing to backup')
return
end
   do i = 1 to incluir.0 by 1
   newi=newi+1
   if incluir.0=i then mas=''
	if i=1 then
	do
	Lin.newi="positiv=" '"' || incluir.i ||'"intro' mas','
	end
        else
        do
        Lin.newi='"' || incluir.i ||'"intro' mas','
        end
   end /* end do */

newi=newi+1   
Lin.newi="/* no quitar este comentario, o suprimir la ultima coma*/" /*mantener este espacio*/
newi=newi+1
lin.newi='call crear_tempin /* genera un fichero temporal con los files a incluir */'
mas='||'
     do i = 1 to excluir.0 by 1
     newi=newi+1
     if excluir.0=i then mas=''

	if i=1 then
	do
	Lin.newi="negativ=" '"' || excluir.i ||'"intro' mas','
	end
        else
        do
        Lin.newi='"' || excluir.i ||'"intro' mas','
        end
     end /* end do */
newi=newi+1
Lin.newi="/* no quitar este comentario, o suprimir la ultima coma*/" 
newi=newi+1
Lin.newi='call crear_tempout /* genera files a excluir */     '
A_CREAR='A_CREAR'
newi=newi+1
Lin.newi="'"rarprog compres "'" A_CREAR || "'"'\'|| substr(nameprog,1,7) "'," 
newi=newi+1
este='@'||nameprog||'Tempin.txt'
Lin.newi="'"este"',"
newi=newi+1
Lin.newi="'" properti "',"
newi=newi+1
este='-x@'||nameprog||'Tempout.txt'
Lin.newi="'"este"'"
newi=newi+1
Lin.newi="call errorRar(rc) "
newi=newi+1
Lin.newi="end"
newi=newi+1
Lin.newi="else"

newi=newi+1
Lin.newi="do"
newi=newi+1
Lin.newi="say 'Do not created the path, abort the copy 'nameprog intro 'Error operation canceled'  "
newi=newi+1
Lin.newi="end"
newi=newi+1
call generador_files /*carga la variable rutinas */
Lin.newi=rutinas
newi=newi+250 /*********** ojoj este es el numero de lineas para el generador_files**/
/*gravarlo too*/
call save_prog_too

CALL VpWindow window,'CLOSE' 


return

exit

generador_files:
rutinas='exit'intro,
'/*****error***********/'intro,
'error:'intro,
" call errorRar(rc)"intro,
" say 'Push any key...'"intro,
'pull'intro,
'return'intro,
" /*****errorRar***********/"intro,
"  errorRar:"intro,
"  arg rec"intro,
"select"intro,
"  when rec=255 then do ; err='   USER BREAK(255)  User stopped the process';end"intro,
"  when rec= 9  then do ; err='  CREATE ERROR(9)   Create file error';end"intro,
"  when rec= 8  then do ; err=' MEMORY ERROR(8)    Not enough memory for operation';end"intro,
"  when rec= 7  then do ; err=' USER ERROR(7)      Command line option error';end"intro,
"  when rec= 6  then do ; err=' OPEN ERROR(6)      Open file error';end"intro,
"  when rec= 5  then do ; err=' WRITE ERROR(5)     Write to disk error';end"intro,
'  when rec= 4  then do ; err=" LOCKED ARCHIVE(4)  Attempt to modify an archive previously locked by the -k- command";end'intro,
'  when rec= 3  then do ; err=" CRC ERROR(3)       A CRC error occurred when unpacking";end'intro,
'  when rec= 2  then do ; err=" FATAL ERROR(2)     A fatal error occurred";end'intro,
'  when rec= 1  then do ; err=" WARNING(1)         Non fatal error(s) occurred";end'intro,
'  when rec= 0  then do ; err=" SUCCESS(0)         Successful operation (User exit)";end'intro,
'  when rec=-1  then do ; err="LAN:(-1)            No password specified for user ID.";end'intro,
'  when rec=-2  then do ; err="LAN:(-2)            Network logon was unsuccessful.";end'intro,
'  otherwise do'intro,
"  err='Unknown error with number ' rec ; end"intro,
"end"intro,
"say err 'in program 'nameprog'.cmd'"intro,
"if rec=0 then "intro,
"do"intro,
"  say 'Push any key...'"intro,
" pull"intro,
"end"intro,
"erase nameprog||'Tempin.txt'"intro,
"erase nameprog||'Tempout.txt'"intro,
"return"intro,
'/*****crear_tempin********/'intro,
'crear_tempin:'intro,
'arg nada'intro,
"filename=directory()||'\'||nameprog||'Tempin.txt'"intro,
"signal off error"intro,
"erase filename"intro,
"if rc=2 | rc=1 then rc=0"intro,
"signal on error"intro,
"/*se posiciona en la primera linea para escribir*/"intro,
"rc=LINEOUT(filename,,1)"intro,
"rc=LINEOUT(filename,translate(positiv),1)"intro,
"	if rc<>0  then"intro,
"	do"intro,
"	say 'Bad file save *'nameprog||'Tempin.txt*, with rc= 'rc intro'Error saving file'"intro,
"	end"intro,
"rc=Stream(FileName,'c','close')"intro,
"return nada"intro,
" "intro,
'/*****crear_tempout********/'intro,
"crear_tempout:"intro,
"arg nada"intro,
"if negativ='NEGATIV' then negativ=''"intro,
"filename=directory()||'\'||nameprog||'Tempout.txt'"intro,
"signal off error"intro,
"erase filename"intro,
"if rc=2 | rc=1 then rc=0"intro,
"signal on error"intro,
"/*se posiciona en la primera linea para escribir*/"intro,
"rc=LINEOUT(filename,,1)"intro,
"rc=LINEOUT(filename,translate(negativ),1)"intro,
"	if rc<>0  then"intro,
"	do"intro,
"	say 'Bad file save *'nameprog||'Tempout.txt*, with rc= 'rc intro'Error saving file'"intro,
"	end"intro,
"rc=Stream(FileName,'c','close')"intro,
"return nada"intro,
"exit"intro,
"/******end program automatic generation*******/"intro,
"/********************************************************/"intro
return rutinas







save_prog_too:
filename=newp
/*se posiciona en la primera linea para escribir*/
rc=LINEOUT(filename,,1)
do i=1 to newi
if lin.i="LIN."||i then Lin.i=""
IF lin.i="" then ITERATE
rc=Lineout(FileName,Lin.i)
/*say i lin.i*/
	if rc<>0  then
	do
	response=VpMessageBox(window,'Error saving file','Bad file save 'nameprog'.cmd, with rc= 'rc)	
	end
end /* end do */

/*aadido para eliminar las lineas de basura del anterior programa */
/*pone a blanco las lineas de basura*/
do while lines(filename)<>0
rc=lineout(filename,'')
end /* end do */



rc=Stream(FileName,'c','close')
/*rc=Lineout(Filename)*/
lc=0
Lin.0=0

return

/* ##SUB_save_rar */
save_rar: /* save el fichero programa */
/* usado por Rarval - save  ya no*/
/* ahora lo usa CREATION para guardar el programa creado*/
/*Arg window self*/

filename=directory()||'\'||rarval.txt
/*se posiciona en la primera linea para escribir*/
rc=LINEOUT(filename,,1)
do i=1 to lc
rc=Lineout(FileName,rar.i)
	if rc<>0  then
	do
	response=VpMessageBox(window,'Error saving file','Bad file save *Rarval.txt*, with rc= 'rc)	
	end
end /* end do */
rc=Stream(FileName,'c','close')
lc=0
rar.0=0
return
